# Code generated by `py-sdk-gen`. DO NOT EDIT.
from datetime import datetime
import typing
import pydantic


class Invite(pydantic.BaseModel):
    """
    Pending invitation for membership.
    """

    email: str
    """
	Email address of the invited user.
	Format: email
	"""

    expires_at: datetime


MembershipStatus = typing.Literal["accepted", "disabled", "expired", "pending", "unknown"]

Metadata = dict[typing.Any, typing.Any]
"""
Set of user-defined key-value pairs attached to the object. Partial updates are not supported. When updating, alwayssubmit whole metadata.
"""

Attributes = dict[typing.Any, typing.Any]
"""
Object attributes that modifiable only by SumUp applications.
"""

MembershipResourceType = typing.Literal["merchant"]


class MembershipResource(pydantic.BaseModel):
    """
    Information about the resource the membership is in.
    """

    attributes: Attributes
    """
	Object attributes that modifiable only by SumUp applications.
	"""

    created_at: datetime
    """
	The timestamp of when the membership resource was created.
	"""

    id: str
    """
	ID of the resource the membership is in.
	"""

    name: str
    """
	Display name of the resource.
	"""

    type: MembershipResourceType

    updated_at: datetime
    """
	The timestamp of when the membership resource was last updated.
	"""

    logo: typing.Optional[str] = None
    """
	Logo fo the resource.
	Format: uri
	Max length: 256
	"""


MembershipType = typing.Literal["merchant"]


class Membership(pydantic.BaseModel):
    """
    A membership associates a user with a resource, memberships is defined by user, resource, resource type, andassociated roles.
    """

    created_at: datetime
    """
	The timestamp of when the membership was created.
	"""

    id: str
    """
	ID of the membership.
	"""

    permissions: list[str]
    """
	User's permissions.
	"""

    resource: MembershipResource
    """
	Information about the resource the membership is in.
	"""

    resource_id: str
    """
	ID of the resource the membership is in.
	"""

    roles: list[str]
    """
	User's roles.
	"""

    status: MembershipStatus
    """
	The status of the membership.
	"""

    type: MembershipType
    """
	Type of the resource the membership is in.
	"""

    updated_at: datetime
    """
	The timestamp of when the membership was last updated.
	"""

    attributes: typing.Optional[Attributes] = None
    """
	Object attributes that modifiable only by SumUp applications.
	"""

    invite: typing.Optional[Invite] = None
    """
	Pending invitation for membership.
	"""

    metadata: typing.Optional[Metadata] = None
    """
	Set of user-defined key-value pairs attached to the object. Partial updates are not supported. When updating, alwayssubmit whole metadata.
	"""
