# Code generated by `py-sdk-gen`. DO NOT EDIT.
from .._service import Resource, AsyncResource, HeaderTypes
from .types import FinancialPayouts
from datetime import date
import typing
import pydantic


class ListPayoutsV1Params(pydantic.BaseModel):
    """
    ListPayoutsV1Params: query parameters for ListPayoutsV1
    """

    end_date: date

    start_date: date

    format: typing.Optional[str] = None

    limit: typing.Optional[int] = None

    order: typing.Optional[str] = None


class ListPayoutsParams(pydantic.BaseModel):
    """
    ListPayoutsParams: query parameters for ListPayouts
    """

    end_date: date

    start_date: date

    format: typing.Optional[str] = None

    limit: typing.Optional[int] = None

    order: typing.Optional[str] = None


class PayoutsResource(Resource):
    def __init__(self, client):
        super().__init__(client)

    def list(
        self,
        merchant_code: str,
        params: typing.Optional[ListPayoutsV1Params] = None,
        headers: typing.Optional[HeaderTypes] = None,
    ) -> FinancialPayouts:
        """
        List payouts

        Lists ordered payouts for the merchant profile.
        """
        resp = self._client.get(
            f"/v1.0/merchants/{merchant_code}/payouts",
            params=params.dict() if params else None,
            headers=headers,
        )
        return pydantic.TypeAdapter(FinancialPayouts).validate_python(resp.json())

    def list_deprecated(
        self,
        params: typing.Optional[ListPayoutsParams] = None,
        headers: typing.Optional[HeaderTypes] = None,
    ) -> FinancialPayouts:
        """
        List payouts

        Lists ordered payouts for the merchant profile.

        Deprecated: this operation is deprecated
        """
        resp = self._client.get(
            "/v0.1/me/financials/payouts",
            params=params.dict() if params else None,
            headers=headers,
        )
        return pydantic.TypeAdapter(FinancialPayouts).validate_python(resp.json())


class AsyncPayoutsResource(AsyncResource):
    def __init__(self, client):
        super().__init__(client)

    async def list(
        self,
        merchant_code: str,
        params: typing.Optional[ListPayoutsV1Params] = None,
        headers: typing.Optional[HeaderTypes] = None,
    ) -> FinancialPayouts:
        """
        List payouts

        Lists ordered payouts for the merchant profile.
        """
        resp = await self._client.get(
            f"/v1.0/merchants/{merchant_code}/payouts",
            params=params.dict() if params else None,
            headers=headers,
        )
        return pydantic.TypeAdapter(FinancialPayouts).validate_python(resp.json())

    async def list_deprecated(
        self,
        params: typing.Optional[ListPayoutsParams] = None,
        headers: typing.Optional[HeaderTypes] = None,
    ) -> FinancialPayouts:
        """
        List payouts

        Lists ordered payouts for the merchant profile.

        Deprecated: this operation is deprecated
        """
        resp = await self._client.get(
            "/v0.1/me/financials/payouts",
            params=params.dict() if params else None,
            headers=headers,
        )
        return pydantic.TypeAdapter(FinancialPayouts).validate_python(resp.json())
