# Code generated by `py-sdk-gen`. DO NOT EDIT.
from datetime import datetime
import typing
import pydantic

Metadata = dict[typing.Any, typing.Any]
"""
Set of user-defined key-value pairs attached to the object. Partial updates are not supported. When updating, alwayssubmit whole metadata.
"""


class Role(pydantic.BaseModel):
    """
    A custom role that can be used to assign set of permissions to members.
    """

    created_at: datetime
    """
	The timestamp of when the role was created.
	"""

    id: str
    """
	Unique identifier of the role.
	"""

    is_predefined: bool
    """
	True if the role is provided by SumUp.
	"""

    name: str
    """
	User-defined name of the role.
	"""

    permissions: list[str]
    """
	List of permission granted by this role.
	Max items: 100
	"""

    updated_at: datetime
    """
	The timestamp of when the role was last updated.
	"""

    description: typing.Optional[str] = None
    """
	User-defined description of the role.
	"""

    metadata: typing.Optional[Metadata] = None
    """
	Set of user-defined key-value pairs attached to the object. Partial updates are not supported. When updating, alwayssubmit whole metadata.
	"""
